# SPDX-FileCopyrightText: 2021 The eminus developers
# SPDX-License-Identifier: Apache-2.0
from dataclasses import dataclass
from typing import Any

from numpy import floating
from numpy.typing import NDArray

def lda_xc_gdsmfb(
    n: NDArray[floating],
    T: float = ...,
    **kwargs: Any,
) -> tuple[NDArray[floating], NDArray[floating], None]: ...
def lda_xc_gdsmfb_spin(
    n: NDArray[floating],
    zeta: NDArray[floating],
    T: float = ...,
    **kwargs: Any,
) -> tuple[NDArray[floating], NDArray[floating], None]: ...
@dataclass
class Coefficients:
    theta: NDArray[floating]
    a0: float = ...
    a1: float = ...
    a2: float = ...
    a3: float = ...
    a4: float = ...
    a5: float = ...
    a6: float = ...
    @property
    def b5(self) -> float: ...
    @property
    def a(self) -> NDArray[floating]: ...
    @property
    def dadtheta(self) -> NDArray[floating]: ...
    @property
    def b(self) -> NDArray[floating]: ...
    @property
    def dbdtheta(self) -> NDArray[floating]: ...
    @property
    def c(self) -> NDArray[floating]: ...
    @property
    def dcdtheta(self) -> NDArray[floating]: ...
    @property
    def d(self) -> NDArray[floating]: ...
    @property
    def dddtheta(self) -> NDArray[floating]: ...
    @property
    def e(self) -> NDArray[floating]: ...
    @property
    def dedtheta(self) -> NDArray[floating]: ...

@dataclass
class Zeta0Coeffs(Coefficients):
    omega: float = ...
    b1: float = ...
    b2: float = ...
    b3: float = ...
    b4: float = ...
    c1: float = ...
    c2: float = ...
    d1: float = ...
    d2: float = ...
    d3: float = ...
    d4: float = ...
    d5: float = ...
    e1: float = ...
    e2: float = ...
    e3: float = ...
    e4: float = ...
    e5: float = ...

@dataclass
class Zeta1Coeffs(Coefficients):
    omega: float = ...
    b1: float = ...
    b2: float = ...
    b3: float = ...
    b4: float = ...
    c1: float = ...
    c2: float = ...
    d1: float = ...
    d2: float = ...
    d3: float = ...
    d4: float = ...
    d5: float = ...
    e1: float = ...
    e2: float = ...
    e3: float = ...
    e4: float = ...
    e5: float = ...

@dataclass
class PhiParams:
    h1: float = ...
    h2: float = ...
    lambda1: float = ...
    lambda2: float = ...
